
/*=============================================================================
	UI Uniforms
=============================================================================*/
#define LumCoeff float3(0.212656, 0.715158, 0.072186)
uniform float Frametime < source = "frametime";>;

#ifndef ARCANE_BLOOM_USE_ADAPTATION
#define ARCANE_BLOOM_USE_ADAPTATION 1
#endif
uniform float  HDRLevel <
	ui_label   = "HDRLevels";
	ui_tooltip = "Default: 1.5";
	ui_type    = "drag";
	ui_min     = 1.0;
	ui_max     = 3.0;
	ui_step    = 0.1;
> = 2.0;

uniform float  white_point <
	ui_label   = "White Point";
	ui_type    = "drag";
	ui_min     = 1;
	ui_max     = 150.0;
	ui_step    = 1;
> = 130.0;

uniform float ReinhardLinearSlope <
	ui_label   = "Linear Slope";
	ui_type = "drag";
	ui_min = 1.0; ui_max = 5.0;
	ui_tooltip = "how steep the color curve is at linear point";
> = 0.80;

uniform float ReinhardLinearWhitepoint <
	ui_label   = "Linear White Point";
	ui_type = "drag";
	ui_min = 0.0; ui_max = 20.0;
	ui_tooltip = "...";
> = 1.700;


uniform float ReinhardLinearPoint <
	ui_label   = "Linear Point";
	ui_type = "drag";
	ui_min = 0.0; ui_max = 2.0;
	ui_tooltip = "...";
> = 0.150;


uniform float HDRPower <
	ui_type = "drag";
	ui_min = 0.0; 
                ui_max = 8.0;
	ui_step    = 0.1;
	ui_label = "Black Point";
> = 0.25;

uniform float Exposurestance <
	ui_label   = "Max Brightness";
	ui_tooltip = "Default: 1.0";
	ui_type    = "drag";
	ui_min     = 0;
	ui_step    = 1;
	ui_max     = 1000.0;
> = 1.0;

uniform float Colourfulness <
	ui_type = "drag";
	ui_tooltip = "Default: 0.3";
	ui_min = 0.0; 
                ui_max = 1.0;
	ui_step = 0.1;
> = 0.25;
/*
uniform float ShoulderStrength <
	ui_label   = "Shoulder Strength";
	ui_tooltip = "Default: 2.51";
	ui_type    = "drag";
	ui_min     = 0.001;
	ui_max     = 3.0;
	ui_step    = 0.001;
> = 2.51;
*/
/*
uniform float LinearStrength <
	ui_label   = "Linear Strength";
	ui_tooltip = "Default: 0.03";
	ui_type    = "drag";
	ui_min     = 0.001;
	ui_max     = 1.0;
	ui_step    = 0.001;
> = 1.3;
*/
/*
uniform float LinearAngle <
	ui_label   = "Linear Angle";
	ui_tooltip = "Default: 1.5";
	ui_type    = "drag";
	ui_min     = 0.001;
	ui_max     = 3.0;
	ui_step    = 0.001;
> = 0.18;
*/
/*
uniform float ToeStrength <
	ui_label   = "Toe Strength";
	ui_tooltip = "Default: 0.59";
	ui_type    = "drag";
	ui_min     = 0.001;
	ui_max     = 1.0;
	ui_step    = 0.001;
> = 0.59;
*/
/*
uniform float ToeDenominator <
	ui_label   = "Toe Denominator";
	ui_tooltip = "Default: 0.14";
	ui_type    = "drag";
	ui_min     = 0.001;
	ui_max     = 1.0;
	ui_step    = 0.001;
> = 0.5;
*/
#if ARCANE_BLOOM_USE_ADAPTATION
uniform float Adapt_Intensity <
	ui_label   = "Adaptation Intensity";
	ui_tooltip = "Default: 1.0";
	ui_type    = "drag";
	ui_min     = 0.0;
	ui_max     = 1.0;
	ui_step    = 0.001;
> = 1.0;

uniform float AdpSpeed <
    ui_label = "AdaptionSpeed";
    ui_tooltip = "Speed of adaption. The higher the faster";
    ui_type = "drag";
    ui_min = 0.0;
    ui_max = 1.0;
    ui_step = 0.001;
> = 1.0;

uniform int Adapt_Precision <
	ui_label   = "Adaptation Precision";
	ui_tooltip = "Default: 0";
	ui_type    = "drag";
	ui_min     = 0;
	ui_max     = 11;
	ui_step    = 0.01;
> = 0;

uniform float2 Adapt_Limits <
	ui_label   = "Adaptation(Min/Max)";
	ui_tooltip = "Default: (0.0, 1.0)";
	ui_type    = "drag";
	ui_min     = 0.0;
	ui_max     = 1.0;
	ui_step    = 0.001;
> = float2(1.0, 1.0);

uniform int iBloomMixmode <
	ui_type = "combo";
	ui_items = "Linear add\0Screen add\0Screen/Lighten/Opacity\0Lighten\0";
> = 1;

uniform float	BloomThreshold<
    ui_type = "drag";
    ui_min = 0.0;
    ui_max = 5.0;
> = 0.0;

uniform float	BloomAmount <
    ui_type = "drag";
    ui_min = 0.0;
    ui_max = 5.0;
> = 2.0;
/*
uniform float	BloomCurve <
    ui_type = "drag";
    ui_min = 0.0;
    ui_max = 5.0;
> = 1.0;
*/
/*
uniform float BloomSaturation <
	ui_type = "drag";
	ui_min = 0.0;
        ui_max = 10.0;
> = 2.0;
*/
#endif
/*
uniform uint uiTonemapper <
	ui_label = "Tonemapper";
	ui_type = "combo";
	ui_items = "Pow\0ACESFilmic\0";
> = 1;
*/
/*=============================================================================
	Textures, Samplers, Globals
=============================================================================*/

#include "ReShade.fxh"

sampler2D sBackBuffer {
	Texture     = ReShade::BackBufferTex;
	SRGBTexture = true;
};

texture texLum1
{
	Width = BUFFER_WIDTH;
	Height = BUFFER_HEIGHT;
	Format = RGBA32F;
};

texture texLum2
{
	Width = BUFFER_WIDTH;
	Height = BUFFER_HEIGHT;
	Format = RGBA32F;
};

sampler SamplerLum1 { Texture = texLum1; };
sampler SamplerLum2 { Texture = texLum2; };

texture2D texHDR { Width = BUFFER_WIDTH; Height = BUFFER_HEIGHT; Format = RGBA32F; };
sampler2D SamplerHDR { Texture = texHDR;};

#if ARCANE_BLOOM_USE_ADAPTATION
texture texBloom1
{
	Width = BUFFER_WIDTH;
	Height = BUFFER_HEIGHT;
	Format = RGBA16F;
        MipLevels = 4;
};
texture texBloom2
{
	Width = BUFFER_WIDTH / 2;
	Height = BUFFER_HEIGHT / 2;
	Format = RGBA16F;
        MipLevels = 4;
};
texture texBloom3
{
	Width = BUFFER_WIDTH / 4;
	Height = BUFFER_HEIGHT / 4;
	Format = RGBA16F;
        MipLevels = 3+2;
};
texture texBloom4
{
	Width = BUFFER_WIDTH / 8;
	Height = BUFFER_HEIGHT / 8;
	Format = RGBA16F;
        MipLevels = 4;
};
texture texBloom5
{
	Width = BUFFER_WIDTH / 16;
	Height = BUFFER_HEIGHT / 16;
	Format = RGBA16F;
        MipLevels = 3+2;
};

sampler SamplerBloom1 { Texture = texBloom1; };
sampler SamplerBloom2 { Texture = texBloom2; };
sampler SamplerBloom3 { Texture = texBloom3; };
sampler SamplerBloom4 { Texture = texBloom4; };
sampler SamplerBloom5 { Texture = texBloom5; };
texture2D CombineTex { Width = BUFFER_WIDTH; Height = BUFFER_HEIGHT; Format = RGBA16F; };
sampler2D SamplerCombine { Texture = CombineTex;};

texture2D texLuminance { Width = 1024; Height = 1024;  Format = R32F; MipLevels = 11;};
texture2D texAdapt { Format = R32F;};
texture2D texAvgLuminanceLast { Format = R32F;};

sampler SamplerLuminance { Texture = texLuminance; };
sampler SamplerADAPT { Texture = texAdapt; MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = LINEAR; AddressU  = CLAMP; AddressV  = CLAMP; AddressW  = CLAMP;};
sampler SamplerAvgLuminanceLast { Texture = texAvgLuminanceLast; MinFilter = LINEAR; MagFilter = LINEAR; MipFilter = LINEAR; AddressU  = CLAMP; AddressV  = CLAMP; AddressW  = CLAMP;};
#endif

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


/*=============================================================================
	Functions
=============================================================================*/
float get_luma_linear(float3 c) {
	return dot(c, float3(0.2126, 0.7152, 0.0722));
}

#if ARCANE_BLOOM_USE_ADAPTATION

float PS_Luminance(float4 pos : SV_Position, float2 uv : TEXCOORD) : SV_Target
{
	float3 color = tex2D(SamplerHDR, uv);
	return float4(get_luma_linear(color), 0.0, 0.0, 1.0);
}

float PS_ADAPT(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
   float adapt = tex2Dlod(SamplerLuminance, float4(texcoord, 0, 11 - Adapt_Precision)).x;
           //adapt *= Adapt_Sensitivity;

           adapt = clamp(adapt, Adapt_Limits.x, Adapt_Limits.y);

   float last = tex2D(SamplerAvgLuminanceLast, 0).x;
           adapt = lerp(last, adapt, (Frametime * 0.001)/AdpSpeed);

   return float4(adapt, 0.0, 0.0, 1.0);
}

float PS_StoreAvgLuminance(float4 pos : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
   return tex2D(SamplerADAPT, 0.0);
}

#endif

float3 ACESFilmic (in float3 x)
{

     float a =  2.51;//ShoulderStrength; //2.51f; //
     float b =  0.03;//LinearStrength; //0.03f; //
     float c =  2.43;//LinearAngle; //2.43f; //
     float d =  0.59;//ToeStrength; //0.59f; // 
     float e =  0.14;//ToeDenominator; //0.14f; //
     x = (x * (a * x + b)) / (x * (c * x + d) + e);
     return x;
}

float3 Rec2020(in float3 color)
{
	float Kr = 0.2627; 
	float Kg = 0.678; 
	float Kb = 0.0593;
	float Y = Kr*color.r + (1-Kr-Kb)*color.g + Kb*color.b;
	float Cr = (2.0*(color.r - Y) / (1 - Kr)) * Colourfulness;
	float Cb = (2.0*(color.b - Y) / (1 - Kb)) * Colourfulness;
	color.r= 1.164*Y+1.596*Cr;
	color.g = 1.164*Y-0.392*Cb-0.813*Cr;
	color.b = 1.164*Y+2.017*Cb;
                color *= 1000f;
	float white_point_float = 940 == 64 ? (1000.0 / 0.001) : ((940 - 64) / 1000.0); 
	float black_point_float = 64 / 940; 

	return  (color * white_point_float - (black_point_float *  white_point_float)) / max(1.0 - color, 10000 / Exposurestance);
}

float3 Col1(float4 vpos : SV_Position, float2 texcoord : TEXCOORD) : SV_TARGET 
{
	float3 color_sum1 = tex2D(ReShade::BackBuffer, texcoord).rgb;
                color_sum1 *= pow(2.0f, -HDRLevel);
                return color_sum1;
}

float3 Col2(float4 vpos : SV_Position, float2 texcoord : TEXCOORD) : SV_TARGET 
{
	float3 color_sum2 = tex2D(ReShade::BackBuffer, texcoord).rgb;
                color_sum2 *= pow(2.0f, HDRLevel);
	return color_sum2;
}

float3 GetHDR(float4 vpos : SV_Position, float2 texcoord : TEXCOORD) : SV_TARGET 
{
	float3 color = tex2D(ReShade::BackBuffer, texcoord);
                float3 col1 = tex2D(SamplerLum1,texcoord.xy);
                float3 col2 = tex2D(SamplerLum2,texcoord.xy);

	float3 HDR = Rec2020(lerp(col1, color, col2));
                float3 recol = pow(abs(HDR), abs(HDRPower)) + HDR;
                float3 recolor = pow(recol, 2.2);

        const float W = ReinhardLinearWhitepoint;	        // Linear White Point Value
    	const float L = ReinhardLinearPoint;           // Linear point
    	const float C = ReinhardLinearSlope;           // Slope of the linear section
    	const float K = (1 - L * C) / C; // Scale (fixed so that the derivatives of the Reinhard and linear functions are the same at x = L)
    	float3 reinhard = L * C + (1 - L * C) * (1 + K * (recolor - L) / ((W - L) * (W - L))) * (recolor - L) / (recolor - L + K);

    	recolor = (recolor > L) ? reinhard : C * recolor;

                //float White = 1000 /  max(1.0 - recolor, Exposurestance);
                float White = 100 /  white_point;     

                recolor = ACESFilmic(pow(recolor, 1.0)) / ACESFilmic(White);

              return saturate(recolor);
}

#if ARCANE_BLOOM_USE_ADAPTATION

float4 GaussBlur22(float2 coord, sampler tex, float mult, float lodlevel, bool isBlurVert)
{
	float4 sum = 0;
	float2 axis = isBlurVert ? float2(0, 1) : float2(1, 0);

	const float weight[11] = {
		0.082607,
		0.080977,
		0.076276,
		0.069041,
		0.060049,
		0.050187,
		0.040306,
		0.031105,
		0.023066,
		0.016436,
		0.011254
	};

	for (int i = -10; i < 11; i++)
	{
		float currweight = weight[abs(i)];
		sum += tex2Dlod(tex, float4(coord.xy + axis.xy * (float)i * ReShade::PixelSize * mult, 0, lodlevel)) * currweight;
	}

	return sum;
}


void BloomPass0(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float4 bloom : SV_Target)
{
	bloom = 0.0;

	const float2 offset[4] = {
		float2(0.25, 0.25),
		float2(0.25, -0.25),
		float2(-0.25, 0.25),
		float2(-0.25, -0.25)
	};

	for (int i = 0; i < 4; i++)
	{
		float2 bloomuv = offset[i] * ReShade::PixelSize.xy * 4;
		bloomuv = (bloomuv*ReShade::PixelSize.xy)+texcoord;
		float4 tempbloom=tex2D(SamplerHDR, bloomuv.xy);
		tempbloom.xyz = max(0, tempbloom.xyz - BloomThreshold); 
		bloom += tempbloom;
	}

	bloom *= 0.125;

	bloom.xyz=min(bloom.xyz, 32768.0);
	bloom.xyz=max(bloom.xyz, 0.0);
}

void BloomPass1(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float4 bloom : SV_Target)
{
	bloom = 0.0;

	const float2 offset[8] = {
		float2(1.0, 1.0),
		float2(0.0, -1.0),
		float2(-1.0, 1.0),
		float2(-1.0, -1.0),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0)
	};

	for (int i = 0; i < 8; i++)
	{
		float2 bloomuv = offset[i] * ReShade::PixelSize * 4;
		bloomuv += texcoord;
		bloom += tex2Dlod(SamplerBloom1, float4(bloomuv, 0, 0));
	}

	bloom *= 0.125;
}

void BloomPass2(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float4 bloom : SV_Target)
{
	bloom = 0.0;

	const float2 offset[8] = {
		float2(0.707, 0.707),
		float2(0.707, -0.707),
		float2(-0.707, 0.707),
		float2(-0.707, -0.707),
		float2(0.0, 1.0),
		float2(0.0, -1.0),
		float2(1.0, 0.0),
		float2(-1.0, 0.0)
	};

	for (int i = 0; i < 8; i++)
	{
		float2 bloomuv = offset[i] * ReShade::PixelSize * 8;
		bloomuv += texcoord;
		bloom += tex2Dlod(SamplerBloom2, float4(bloomuv, 0, 0));
	}

	bloom *= 0.5; // brighten up the sample, it will lose brightness in H/V Gaussian blur
}

void BloomPass3(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float4 bloom : SV_Target)
{
	bloom = GaussBlur22(texcoord.xy, SamplerBloom3,16,0,0);
	bloom.xyz *= BloomAmount;
	//bloom.xyz *= pow(bloom.xyz, BloomCurve) * BloomAmount;
}

void BloomPass4(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float4 bloom : SV_Target)
{
	bloom = GaussBlur22(texcoord.xy, SamplerBloom4,16,0,1);
}
#endif
//===================================================================================================================

float3 ToneMap(float4 vpos : SV_Position, float2 texcoord : TEXCOORD0) : SV_Target
{  
	float3 recol = tex2D(SamplerHDR, texcoord);

	#if ARCANE_BLOOM_USE_ADAPTATION
                float adapt = tex2D(SamplerADAPT, 0.0).x;
	float exposure = 1.0 / max(adapt, 0.001);
	recol *= lerp(1.0, exposure, Adapt_Intensity);

	// Bloom
	float3 colorbloom = 0;
	colorbloom = tex2D(SamplerBloom3, texcoord).rgb
	                  + tex2D(SamplerBloom5, texcoord).rgb;
	colorbloom *= 0.1;

	if (iBloomMixmode == 0)
		recol.rgb += colorbloom;
	else if (iBloomMixmode == 1)
		recol.rgb = 1 - (1 - recol.rgb) * (1 - colorbloom);
	else if (iBloomMixmode == 2)
		recol.rgb = max(0.0f, max(recol.rgb, lerp(recol.rgb, (1 - (1 - saturate(colorbloom)) * (1 - saturate(colorbloom))), 1.0)));
	else if (iBloomMixmode == 3)
		recol.rgb = max(recol.rgb, colorbloom);
	#endif

     return recol;
}

/*=============================================================================
	Techniques
=============================================================================*/

technique TrueHDR
{
  pass  {
        VertexShader = PostProcessVS;
        PixelShader = Col1;
        RenderTarget = texLum1;
    }

  pass  {
        VertexShader = PostProcessVS;
        PixelShader = Col2;
        RenderTarget = texLum2;
    }

  pass  {
        VertexShader = PostProcessVS;
        PixelShader = GetHDR;
        RenderTarget = texHDR;	
    }

#if ARCANE_BLOOM_USE_ADAPTATION
  pass  {
        VertexShader = PostProcessVS;
        PixelShader = PS_Luminance;
        RenderTarget = texLuminance;
    }
    pass  {
        VertexShader = PostProcessVS;
        PixelShader = PS_ADAPT;
        RenderTarget = texAdapt;
    }
    pass StoreAvgLuminance
    {
        VertexShader = PostProcessVS;
        PixelShader = PS_StoreAvgLuminance;
        RenderTarget = texAvgLuminanceLast;
    }

	pass BloomPass0
	{
		VertexShader = PostProcessVS;
		PixelShader = BloomPass0;
		RenderTarget = texBloom1;
	}
	pass BloomPass1
	{
		VertexShader = PostProcessVS;
		PixelShader = BloomPass1;
		RenderTarget = texBloom2;
	}
	pass BloomPass2
	{
		VertexShader = PostProcessVS;
		PixelShader = BloomPass2;
		RenderTarget = texBloom3;
	}
	pass BloomPass3
	{
		VertexShader = PostProcessVS;
		PixelShader = BloomPass3;
		RenderTarget = texBloom4;
	}
	pass BloomPass4
	{
		VertexShader = PostProcessVS;
		PixelShader = BloomPass4;
		RenderTarget = texBloom5;
	}
#endif
    pass {
	VertexShader = PostProcessVS;
	PixelShader  = ToneMap;
    }
}
